
Redmine - Defect #20456

3.1-stable/3.1.0: missing commits (omitted from being merged from trunk)

2015-08-01 10:10 - Mischa The Evil

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category:  Estimated time: 0.00 hour

Target version: 3.1.1   

Resolution: Fixed Affected version: 3.1.0

Description

This was reported initially by Ryosuke Hirai in #11253-38:

it seems that issue_query.rb @ Revistion 14406 was not applied to the source code of 3.1.0. I could not find this part after

downloading.

 After I read that I started another round of commit hunting. I have summed up the issues I found – and how I found them, using some

ASCII-"art". See below.

I'll start with a to-do section which list the commits that needs to be merged in 3.1-stable, the commits that can/should be merged in

3.1-stable and the commits that shouldn't be merged into 3.1-stable since they are related to issues that are explicitly targeted to

3.2.0 at the time of writing this.

Then I start a section which compares the commits on trunk versus the commits (backports/merges) on 3.1-stable which in the end

provides a list of commits applied on trunk but not on 3.1-stable, which I in turn used to specify which commits belong to what and

what should be done them. That itself is what I used to fill in the to-do section.

Note that I also include a third 'legend' section to make sure that my "art" can be understood ;-)...

------------------------------

1. To do on 3.1-stable branch:

------------------------------

  * To merge...........: r14405, r14406, r14407, r14408, r14409, r14410, r14454

  * Merge-able.........: r14390, r14391, r14411, r14412, r14413, r14414, r14415, r14416

  * Shouldn't be merged: r14458, r14468, r14469, r14470, r14471

------------------------------

2. Commits scheme & reasoning:

------------------------------

v -> TRUNK

|

|

|

O -> r14378

|\

| \

v  --------->--------- O -> r14379, 3.1 STABLE BRANCH CREATION

v                       \

|                        ---->v

|                             |

8 ->   X14380, X14381, X14388,| X14389, r14390, r14391, X14392, X14394,

       X14396, r14405, r14406,| r14407, r14408, r14409, r14410, r14411,

       r14412, r14413, r14414,| r14415, r14416, X14417, X14428, X14429,

  --<< X14430, X14437, X14440,| X14443, X14446, X14448, X14450, X14451,

 /     r14454, X14455, X14419,| X14420, r14458, X14459, X14460, X14461,

/      r14468, r14469, r14470,| r14471                                  <<------<-

|                             |                                                  |\   

v                             v                                                  ^ ->  ((r => X) =

= (MARKED AS CONFIRMED AS MERGED

|                             |                                                  |/               

   FROM TRUNK TO 3.1-STABLE))

|     --------------------->> | >>---------------------------------------------->-
|     |                       |

|     |                       8   -> r14382, r14385, r14393, r14395, r14397, r14400, r14403,

|     ^                              r14418, r14421, r14422, r14431, r14432, r14433, r14438,

|     ^                              r14441, r14444, r14447, r14449, r14452, r14453, r14456,

|     |                              r14462, r14463, r14464,                                  >>--

--

v     |                                                                                           

 |

v     ----------------------<<   Merged r14461, Merged r14460, Merged r14459, Merged r14455,      

 |  

|                                Merged r14450, Merged r14451, Merged r14448, Merged r14446,      

 O -> MERGE COMMITS, FROM TRUNK

|                                Merged r14443, Merged r14440, Merged r14437, Merged r14430,      

 O    TO 3.1-STABLE

|                                Merged r14429, Merged r14428, Merged r14420, Merged r14419,      

 |

|                                Merged r14417, Merged r14388, Merged r14389, Merged r14396,      

 |

|                                Merged r14394, Merged r14392, Merged r14380, Merged r14381,  <<--

--

|

|

v

v -> WRAPUP & CONCLUSION: COMMITS ON TRUNK AFTER 3.1-STABLE BRANCH CREATION, THAT ARE NOT MERGED I

NTO 3.1-STABLE

v

|

8 --> r14390, r14391,                                  --->>> NOT EXPLICIT 3.1.0, BUT IT WAS PROBA

BLY INTENDED FOR 3.1.X THOUGH

|

8 --> r14405, r14406, r14407, r14408, r14409, r14410,  --->>> EXPLICIT 3.1.0, #11253 AND RELATED

|

8 --> r14411, r14412, r14413, r14414,                  --->>> UNKNOWN, CAN BE BACK-PORTED TO 3.1: 

"CODE (LAYOUT) CLEANUP & HTTP => HTTPS" 

|

8 --> r14415, r14416,                                  --->>> UNKNOWN, MIGHT BE BACK-PORTABLE TO 3

.1: "TRAVIS CHANGES, #20251" 

|

8 --> r14454,                                          --->>> EXPLICIT 3.1.0, "BG LOCALE REORDER",

 #11253 AND RELATED

|

8 --> r14458, r14468, r14469, r14470, r14471           --->>> EXPLICIT 3.2.0

----------

3. Legend:

----------

  *  -, >, >>, <, <<, ^, v: DIRECTION MARKERS

  *                      O: BRANCHPOINT, COMMIT

  *                      8: MULTIPLE COMMITS

  *                    -->: MULTIPLE COMMITS SPECIFICATION

  *                     ->: COMMENT

  *                     =>: == REPLACED BY

  *                 --->>>: CONCLUSION INDICATOR

 I'll leave the scheduling decision (strict: 3.2.0, lenient: 3.1.1) to the committers.

Please note that this issue brings me to issue #18134 again, and in particular to the questions I raised in its note #18134-5 (before

"The examples:"). If SCM-provided merge tracking features are used and maintained correctly, issues like this one and previous 

#18174 could have been spotted right on with some higher certainty. Just my two cents...

Kind regards, Mischa.

Related issues:

Related to Redmine - Feature #11253: Total time spent from subtasks on the is... Closed
Associated revisions

Revision 14533 - 2015-08-31 05:38 - Toshi MARUYAMA

Merged r14406 from trunk to 3.1-stable (#11253, #20456)

Adds "Total spent hours" column available on the issue list.

Revision 14534 - 2015-08-31 05:38 - Toshi MARUYAMA

Merged r14407 from trunk to 3.1-stable (#11253, #20456)

Preload total spent time on the issue list with 1 query.

Revision 14535 - 2015-08-31 05:38 - Toshi MARUYAMA

Merged r14408 from trunk to 3.1-stable (#11253, #20456)

Limit queries to given issues only.

Revision 14536 - 2015-08-31 05:38 - Toshi MARUYAMA

Merged r14409 from trunk to 3.1-stable (#11253, #20456)

Fixes methods comments.

Revision 14537 - 2015-08-31 05:38 - Toshi MARUYAMA

Merged r14410 from trunk to 3.1-stable (#11253, #20456)

Asserts that spent time is preloaded.

Revision 14538 - 2015-08-31 07:22 - Toshi MARUYAMA

Merged r14413 from trunk to 3.1-stable (#20243, #20456)

Use https links instead of http links in ApplicationHelper#avatar_edit_link and Redmine::Info class methods.

Patch by Mischa The Evil.

Revision 14596 - 2015-09-16 05:52 - Toshi MARUYAMA

Merged r14405 from trunk to 3.1-stable (#11253, #20456)

Don't display estimated hours when nil and total is 0.

History

#1 - 2015-08-01 10:11 - Mischa The Evil

- Description updated

#2 - 2015-08-01 10:12 - Mischa The Evil

- Description updated

#3 - 2015-08-01 10:13 - Mischa The Evil

- Related to Feature #11253: Total time spent from subtasks on the issue list added

#4 - 2015-08-01 13:15 - Toshi MARUYAMA

- Description updated

#5 - 2015-08-01 13:44 - Toshi MARUYAMA

Thank you for investigation. I will answer my revisions later.

If SCM-provided merge tracking features are used and maintained correctly

 I almost agree, but SCM is not completed solution.

Rails uses git.

https://github.com/rails/rails

But Rails uses "backport/cherry-pick" model.

https://github.com/rails/rails/pull/19689
1. Revision is committed in master branch.

 https://github.com/rails/rails/commit/7e504927090362d132d4e315c6f22915050fe5ba

2. This master revision is backported in 4.2-stable branch.

 https://github.com/rails/rails/commit/4df216cb12e35c09ae5ec271755e581d692d0326

If they use Git/Mercurial, they should use stable/devel merge strategy.

http://marutosi.bitbucket.org/RxTstudy-20130622/one-html/html/index.html#id252

#6 - 2015-08-31 05:42 - Toshi MARUYAMA

r14390, r14391,

--->>> NOT EXPLICIT 3.1.0, BUT IT WAS PROBABLY INTENDED FOR 3.1.X THOUGH

 I think this is refactoring and not for stable.

#7 - 2015-08-31 05:43 - Toshi MARUYAMA

- Target version set to 3.1.1

#8 - 2015-08-31 07:25 - Toshi MARUYAMA

r14411, r14412, r14413, r14414,

--->>> UNKNOWN, CAN BE BACK-PORTED TO 3.1: "CODE (LAYOUT) CLEANUP & HTTP => HTTPS"

 I have merged r14413 from trunk to 3.1-stable.

I think r14411, r14412 and r14414 are refactoring and not for stable.

#9 - 2015-08-31 07:29 - Toshi MARUYAMA

r14415, r14416,

--->>> UNKNOWN, MIGHT BE BACK-PORTABLE TO 3.1: "TRAVIS CHANGES, #20251"

 r14415 was merged as r14523.

r14416 was merged as r14531.

#10 - 2015-08-31 07:33 - Toshi MARUYAMA

--> r14454,

--->>> EXPLICIT 3.1.0, "BG LOCALE REORDER", #11253 AND RELATED

 Bulgarian translation is well maintained.

#11253 translation is merged as r14533.

#11 - 2015-08-31 07:36 - Toshi MARUYAMA

- Status changed from New to Resolved

I have finished checking revisions in description.

#12 - 2015-09-02 03:20 - Ryosuke Hirai

Mischa and Toshi,

Thank you so much for your dedicated work on this issue!, especially Mischa's deep investigation

#13 - 2015-09-13 16:29 - Jean-Philippe Lang

- Assignee set to Toshi MARUYAMA

Mischa and Toshi, thanks for your respective work. Can we close this for 3.1.1?

#14 - 2015-09-15 06:14 - Mischa The Evil
- Status changed from Resolved to Needs feedback

Jean-Philippe Lang wrote:

[...] Can we close this for 3.1.1?

 Toshi MARUYAMA wrote:

I have finished checking revisions in description.

 Toshi, thanks for the review. I'm ok with your decisions and merges. One question though: did you skip r14405 for any particular reason? After

decision/action is taken on r14405 this issue is completed and can be closed for 3.1.1 inclusion.

Note: please mention the inclusion of #11253 in 3.1.1 instead of 3.1.0 in the 3.1.1 release announcement and changelog entry, since it's now showing

on the changelog as part of 3.1.0.

#15 - 2015-09-16 06:24 - Toshi MARUYAMA

- Status changed from Needs feedback to Resolved

- Assignee changed from Toshi MARUYAMA to Jean-Philippe Lang

Mischa The Evil wrote:

Jean-Philippe Lang wrote:

[...] Can we close this for 3.1.1?

 Toshi MARUYAMA wrote:

I have finished checking revisions in description.

 Toshi, thanks for the review. I'm ok with your decisions and merges. One question though: did you skip r14405 for any particular reason?

 There is no reason. I forgot it.

Note: please mention the inclusion of #11253 in 3.1.1 instead of 3.1.0 in the 3.1.1 release announcement and changelog entry, since it's now

showing on the changelog as part of 3.1.0.

 I keep open for JPL reminder.

#16 - 2015-09-16 06:25 - Toshi MARUYAMA

Toshi MARUYAMA wrote:

Mischa The Evil wrote:

Jean-Philippe Lang wrote:

[...] Can we close this for 3.1.1?

 Toshi MARUYAMA wrote:

I have finished checking revisions in description.

 Toshi, thanks for the review. I'm ok with your decisions and merges. One question though: did you skip r14405 for any particular reason?

 There is no reason. I forgot it.

 I have merged as r14596.

#17 - 2015-09-19 09:30 - Jean-Philippe Lang

- Status changed from Resolved to Closed

- Resolution set to Fixed
Thanks.
